SystemOrganization addCategory: #SieveCommon!
SystemOrganization addCategory: #'SieveCommon-GUI-FilterPanels'!
SystemOrganization addCategory: #'SieveCommon-GUI-Main'!
SystemOrganization addCategory: #'SieveCommon-GUI-Sorting'!
SystemOrganization addCategory: #'SieveCommon-Model-Filters'!
SystemOrganization addCategory: #'SieveCommon-Model-Main'!

Object subclass: #CompiledMethodFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-Model-Filters'!

CompiledMethodFilter class
	instanceVariableNames: 'computationTimeMeasure'!

CompiledMethodFilter class
	instanceVariableNames: 'computationTimeMeasure'!

CompiledMethodFilter subclass: #AnyNameContains
	instanceVariableNames: 'stringFinder string'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-Model-Filters'!

!AnyNameContains class methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/13/2012 16:59'!
string: aString

	^self new string: aString! !

!AnyNameContains methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/13/2012 16:59'!
asMorph

	^('names containing "', string, '"') asMorph! !

!AnyNameContains methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/13/2012 16:59'!
isMeaningful

	^string isEmpty not ! !

!AnyNameContains methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/13/2012 16:59'!
string
	^string! !

!AnyNameContains methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/13/2012 16:59'!
string: aString 

	string := aString.
	stringFinder := [:bigString| (bigString findString: string startingAt: 1 caseSensitive: false) > 0  ].
! !

!AnyNameContains methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/13/2012 17:09'!
value: aCompiledMethod

	^{(aCompiledMethod methodClass name). (aCompiledMethod selector)},(aCompiledMethod methodClass instVarNames) anySatisfy: stringFinder.
	! !

CompiledMethodFilter subclass: #ClassNameOrMethodNameContains
	instanceVariableNames: 'stringFinder string'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-Model-Filters'!

!ClassNameOrMethodNameContains class methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2012 18:51'!
string: aString

	^self new string: aString! !

!ClassNameOrMethodNameContains methodsFor: 'as yet unclassified' stamp: 'hjo 8/27/2012 06:50'!
asMorph

	^('names containing "', string, '"') asMorph! !

!ClassNameOrMethodNameContains methodsFor: 'as yet unclassified' stamp: 'hjo 8/27/2012 19:39'!
isMeaningful

	^string isEmpty not ! !

!ClassNameOrMethodNameContains methodsFor: 'as yet unclassified' stamp: 'hjo 8/26/2012 17:36'!
string
	^string! !

!ClassNameOrMethodNameContains methodsFor: 'as yet unclassified' stamp: 'hjo 8/26/2012 17:36'!
string: aString 

	string := aString.
	stringFinder := [:bigString| (bigString findString: string startingAt: 1 caseSensitive: false) > 0  ].
! !

!ClassNameOrMethodNameContains methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2012 18:54'!
value: aCompiledMethod

	^(stringFinder value: aCompiledMethod methodClass name) or: [stringFinder value: aCompiledMethod selector  ].
	! !

!CompiledMethodFilter class methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2013 10:10'!
computationTimeMeasure
	^computationTimeMeasure setDefault: #computationTimeMeasureDefault for: self withSetter: #computationTimeMeasure:! !

!CompiledMethodFilter class methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2013 10:17'!
computationTimeMeasure: aMeanAndDeviationAgent 

	computationTimeMeasure := aMeanAndDeviationAgent! !

!CompiledMethodFilter class methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2013 10:17'!
computationTimeMeasureDefault
	^MeanAndDeviationAgent new! !

!CompiledMethodFilter methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2013 10:24'!
expectedRunTime
	|m|
	m := self class computationTimeMeasure.
	^m count = 0
		ifTrue: [Float fmax]
		ifFalse: [m mean].! !

!CompiledMethodFilter methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2013 10:39'!
filterIn: aCollection

	^aCollection select: [:compiledMethod| self timeMeasuringValue: compiledMethod ]! !

!CompiledMethodFilter methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2013 10:39'!
filterOut: aCollection

	^aCollection reject: [:compiledMethod| self timeMeasuringValue: compiledMethod ]! !

!CompiledMethodFilter methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2013 10:23'!
timeMeasuringValue: aCompiledMethod

	|answer runTime|
	runTime := [answer := self value: aCompiledMethod] timeToRun.
	self class computationTimeMeasure input: runTime.
	^answer! !

!CompiledMethodFilter methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2012 10:56'!
value: aCompiledMethod

	"return Boolean"
	^self subclassResponsibility.! !

CompiledMethodFilter subclass: #HasPragma
	instanceVariableNames: 'pragmaCriteria'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-Model-Filters'!

!HasPragma class methodsFor: 'as yet unclassified' stamp: 'hjo 4/11/2012 18:51'!
that: aBlock

	^self new pragmaCriteria: aBlock.! !

!HasPragma methodsFor: 'as yet unclassified' stamp: 'hjo 4/11/2012 18:51'!
initialize 

	super initialize.
	pragmaCriteria := [:keyword :arguments| true ].! !

!HasPragma methodsFor: 'as yet unclassified' stamp: 'hjo 4/11/2012 18:55'!
pragmaCriteria: aBlockClosure 

	pragmaCriteria := aBlockClosure! !

!HasPragma methodsFor: 'as yet unclassified' stamp: 'hjo 4/11/2012 18:53'!
value: aCompiledMethod 

	^aCompiledMethod pragmas notEmpty and: [aCompiledMethod pragmas anySatisfy: [:pragma|  pragmaCriteria value: pragma keyword value: pragma arguments ]  ].! !

CompiledMethodFilter subclass: #HasTempNamed
	instanceVariableNames: 'string'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-Model-Filters'!

!HasTempNamed class methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2012 19:52'!
string: aByteString 

	^self new string: aByteString! !

!HasTempNamed methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2012 19:52'!
string: aByteString 

	string := aByteString.! !

!HasTempNamed methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2012 20:51'!
value: aCompiledMethod 

	^aCompiledMethod parseTree body temporaries anySatisfy: [:entry| entry token value = string ].! !

CompiledMethodFilter subclass: #InstanceSideMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-Model-Filters'!

!InstanceSideMethod methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2012 11:14'!
value: aCompiledMethod

	^aCompiledMethod methodClass isMeta not! !

CompiledMethodFilter subclass: #MethodClassCanUnderstand
	instanceVariableNames: 'classFilter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-Model-Filters'!

!MethodClassCanUnderstand class methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2012 11:38'!
message: aSymbol 

	^self new message: aSymbol! !

!MethodClassCanUnderstand methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 21:26'!
isMeaningful
	^classFilter stringOrSymbol notEmpty  ! !

!MethodClassCanUnderstand methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 21:25'!
message

	^classFilter stringOrSymbol! !

!MethodClassCanUnderstand methodsFor: 'as yet unclassified' stamp: 'hjo 8/9/2012 00:21'!
message: aSymbol 

	classFilter := ClassFilterCanUnderstand with: aSymbol! !

!MethodClassCanUnderstand methodsFor: 'as yet unclassified' stamp: 'hjo 8/9/2012 00:22'!
value: aCompiledMethod 

	^classFilter value: aCompiledMethod methodClass! !

CompiledMethodFilter subclass: #MethodClassImplementsMethod
	instanceVariableNames: 'classFilter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-Model-Filters'!

!MethodClassImplementsMethod commentStamp: 'HwaJong 10/2/2013 10:27' prior: 0!
rewrite this by
	creating a ClassFilter class: ClassImplements.
	use it.!

!MethodClassImplementsMethod methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/24/2013 22:35'!
initialize 
	super initialize.
	classFilter := ClassImplementsMethod new.! !

!MethodClassImplementsMethod methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/24/2013 22:35'!
isMeaningful
	self selector isNil ifTrue: [^false].
	^true! !

!MethodClassImplementsMethod methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/24/2013 22:35'!
selector
	^classFilter stringOrSymbol! !

!MethodClassImplementsMethod methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/24/2013 22:36'!
selector: aSymbol
	classFilter stringOrSymbol: aSymbol! !

!MethodClassImplementsMethod methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/24/2013 22:36'!
value: aCompiledMethod

	^classFilter value: (aCompiledMethod methodClass)! !

CompiledMethodFilter subclass: #MethodClassInherits
	instanceVariableNames: 'classFilter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-Model-Filters'!

!MethodClassInherits class methodsFor: 'instance creation' stamp: 'hjo 4/1/2012 10:47'!
methodClass: aClass

	^self new methodClass: aClass! !

!MethodClassInherits methodsFor: 'as yet unclassified' stamp: 'hjo 9/1/2012 12:58'!
isMeaningful
	^true! !

!MethodClassInherits methodsFor: 'accessing' stamp: 'hjo 8/9/2012 00:23'!
methodClass
	^ classFilter referenceClass! !

!MethodClassInherits methodsFor: 'accessing' stamp: 'hjo 8/9/2012 00:24'!
methodClass: aClass
	classFilter := ClassFilterInheritsFrom with: aClass! !

!MethodClassInherits methodsFor: 'as yet unclassified' stamp: 'hjo 8/9/2012 00:26'!
value: aCompiledMethod

	^classFilter value: aCompiledMethod methodClass! !

CompiledMethodFilter subclass: #MethodClassIs
	instanceVariableNames: 'classFilter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-Model-Filters'!

!MethodClassIs class methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2012 11:32'!
methodClass: aClass

	^self new methodClass: aClass! !

!MethodClassIs methodsFor: 'accessing' stamp: 'hjo 8/9/2012 00:26'!
methodClass
	^ classFilter referenceClass! !

!MethodClassIs methodsFor: 'accessing' stamp: 'hjo 8/9/2012 00:27'!
methodClass: aClass
	classFilter := ClassFilterClassIs with: aClass! !

!MethodClassIs methodsFor: 'as yet unclassified' stamp: 'hjo 8/9/2012 00:27'!
value: aCompiledMethod 

	^classFilter value: aCompiledMethod methodClass! !

CompiledMethodFilter subclass: #MethodClassIsClassOrSuperclass
	instanceVariableNames: 'classFilter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-Model-Filters'!

!MethodClassIsClassOrSuperclass class methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2012 11:23'!
methodClass: aClass 

	^self new methodClass: aClass! !

!MethodClassIsClassOrSuperclass methodsFor: 'as yet unclassified' stamp: 'hjo 8/30/2012 10:07'!
isMeaningful
	^true! !

!MethodClassIsClassOrSuperclass methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/1/2012 19:24'!
methodClass
	^classFilter representingClass! !

!MethodClassIsClassOrSuperclass methodsFor: 'as yet unclassified' stamp: 'hjo 8/9/2012 00:29'!
methodClass: aClass 

	classFilter := ClassFilterSuperclassOrClassIs with: aClass.
	! !

!MethodClassIsClassOrSuperclass methodsFor: 'as yet unclassified' stamp: 'hjo 8/30/2012 10:03'!
nameOfMethodClass
	^classFilter positiveClasses first name   ! !

!MethodClassIsClassOrSuperclass methodsFor: 'as yet unclassified' stamp: 'hjo 8/9/2012 00:29'!
value: aCompiledMethod

	^classFilter value: aCompiledMethod methodClass! !

CompiledMethodFilter subclass: #MethodClassNameBegins
	instanceVariableNames: 'classFilter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-Model-Filters'!

!MethodClassNameBegins class methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2012 18:28'!
with: aString

	^self new string: aString! !

!MethodClassNameBegins methodsFor: 'as yet unclassified' stamp: 'hjo 8/9/2012 00:30'!
string

	^classFilter stringOrSymbol.! !

!MethodClassNameBegins methodsFor: 'as yet unclassified' stamp: 'hjo 8/9/2012 00:30'!
string: aString

	classFilter := ClassFilterNameBeginsWith with: aString! !

!MethodClassNameBegins methodsFor: 'as yet unclassified' stamp: 'hjo 8/9/2012 00:31'!
value: aCompiledMethod

	^classFilter value: aCompiledMethod methodClass! !

CompiledMethodFilter subclass: #MethodOfPackage
	instanceVariableNames: 'packageInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-Model-Filters'!

!MethodOfPackage class methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2012 10:57'!
named: aString

	^self new packageInfoNamed: aString! !

!MethodOfPackage methodsFor: 'as yet unclassified' stamp: 'hjo 8/27/2012 06:55'!
asMorph

	^('package "', self packageInfoName, '"') asMorph! !

!MethodOfPackage methodsFor: 'as yet unclassified' stamp: 'hjo 8/27/2012 19:40'!
isMeaningful
	packageInfo isNil ifTrue: [^false].
	packageInfo packageName isEmpty ifTrue: [^false].
	^true.! !

!MethodOfPackage methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2012 10:59'!
packageInfo: aPackageInfo 

	packageInfo := aPackageInfo. ! !

!MethodOfPackage methodsFor: 'as yet unclassified' stamp: 'hjo 8/26/2012 17:47'!
packageInfoName

	^packageInfo packageName! !

!MethodOfPackage methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2012 10:59'!
packageInfoNamed: aByteString 

	self packageInfo: (PackageInfo named: aByteString)! !

!MethodOfPackage methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2012 11:01'!
value: aCompiledMethod

	^packageInfo includesMethod: aCompiledMethod selector ofClass: aCompiledMethod methodClass! !

CompiledMethodFilter subclass: #ReferencesGlobal
	instanceVariableNames: 'string'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-Model-Filters'!

!ReferencesGlobal methodsFor: 'answering' stamp: 'HwaJong 9/29/2013 18:01'!
binding
	^Smalltalk bindingOf: string asSymbol! !

!ReferencesGlobal methodsFor: 'answering' stamp: 'HwaJong 9/29/2013 18:30'!
isMeaningful
	^string notEmpty and: [string first isUppercase]! !

!ReferencesGlobal methodsFor: 'answering' stamp: 'HwaJong 9/29/2013 17:33'!
string
	^string! !

!ReferencesGlobal methodsFor: 'changing' stamp: 'HwaJong 9/29/2013 17:33'!
string: aString
	string := aString! !

!ReferencesGlobal methodsFor: 'answering' stamp: 'HwaJong 9/29/2013 18:01'!
value: aCompiledMethod

	^aCompiledMethod literals allButLast includes: self binding.! !

CompiledMethodFilter subclass: #SelectorBegins
	instanceVariableNames: 'string'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-Model-Filters'!

!SelectorBegins class methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2012 19:06'!
with: aString

	^self new string: aString! !

!SelectorBegins methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2012 19:06'!
string: aString 

	string := aString.! !

!SelectorBegins methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2012 19:07'!
value: aCompiledMethod

	^ aCompiledMethod selector beginsWith: string! !

CompiledMethodFilter subclass: #SelectorContains
	instanceVariableNames: 'string'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-Model-Filters'!

!SelectorContains class methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2012 19:35'!
string: aString

	^self new string: aString! !

!SelectorContains methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2012 19:35'!
string: aString

	string := aString! !

!SelectorContains methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2012 19:35'!
value: aCompiledMethod

	^(aCompiledMethod selector findString: string startingAt: 1 caseSensitive: false) > 0! !

CompiledMethodFilter subclass: #SelectorIs
	instanceVariableNames: 'selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-Model-Filters'!

!SelectorIs class methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2012 21:03'!
selector: aSymbol

	^self new selector: aSymbol! !

!SelectorIs methodsFor: 'as yet unclassified' stamp: 'hjo 8/31/2012 20:54'!
isMeaningful
	^selector isEmpty not! !

!SelectorIs methodsFor: 'as yet unclassified' stamp: 'hjo 8/31/2012 20:52'!
selector
	^ selector! !

!SelectorIs methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2012 21:03'!
selector: aSymbol

	selector := aSymbol! !

!SelectorIs methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2012 21:04'!
value: aCompiledMethod

	^aCompiledMethod selector = selector.! !

CompiledMethodFilter subclass: #SendsMessage
	instanceVariableNames: 'selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-Model-Filters'!

!SendsMessage class methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2012 20:58'!
selector: aSymbol

	^self new selector: aSymbol! !

!SendsMessage methodsFor: 'as yet unclassified' stamp: 'hjo 8/27/2012 06:58'!
asMorph

	^('sends #', selector) asMorph! !

!SendsMessage methodsFor: 'as yet unclassified' stamp: 'hjo 8/27/2012 19:40'!
isMeaningful

	^selector isEmpty not! !

!SendsMessage methodsFor: 'as yet unclassified' stamp: 'hjo 8/26/2012 17:52'!
selector

	^selector! !

!SendsMessage methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2012 20:58'!
selector: aSymbol

	selector := aSymbol.! !

!SendsMessage methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2012 20:59'!
value: aCompiledMethod

	^aCompiledMethod messages includes: selector.! !

CompiledMethodFilter subclass: #SourceCodeContains
	instanceVariableNames: 'string'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-Model-Filters'!

!SourceCodeContains class methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2012 18:37'!
string: aString

	^self new string: aString! !

!SourceCodeContains methodsFor: 'as yet unclassified' stamp: 'HwaJong 9/22/2012 15:21'!
isMeaningful
^string notEmpty! !

!SourceCodeContains methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2012 18:37'!
string

	^string.! !

!SourceCodeContains methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2012 18:38'!
string: aString

	string := aString.! !

!SourceCodeContains methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2012 18:38'!
value: aCompiledMethod

	^(aCompiledMethod getSource indexOfSubCollection: string) > 0! !

Object subclass: #DDMethodSortingType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-GUI-Sorting'!

!DDMethodSortingType methodsFor: 'testing' stamp: 'HwaJong 11/8/2012 13:43'!
isNoSort
^false! !

!DDMethodSortingType methodsFor: 'testing' stamp: 'HwaJong 11/8/2012 14:03'!
isSortByCode
	^false! !

!DDMethodSortingType methodsFor: 'testing' stamp: 'HwaJong 11/8/2012 14:38'!
isSortByComplexity
	^false! !

!DDMethodSortingType methodsFor: 'testing' stamp: 'HwaJong 11/8/2012 18:54'!
isSortByDependency
^false! !

!DDMethodSortingType methodsFor: 'testing' stamp: 'HwaJong 11/8/2012 13:44'!
isSortByName
	^false! !

DDMethodSortingType subclass: #DDNoSort
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-GUI-Sorting'!

!DDNoSort methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/8/2012 14:04'!
isNoSort
^true! !

!DDNoSort methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/13/2012 17:27'!
performSortingOn: aSieve 
! !

!DDNoSort methodsFor: 'printing' stamp: 'HwaJong 11/24/2012 13:20'!
stringForSieveDisplay
^'no sort'! !

DDMethodSortingType subclass: #DDSortByCode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-GUI-Sorting'!

!DDSortByCode methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/15/2012 18:29'!
isSortByCode
	^true! !

!DDSortByCode methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/13/2012 17:27'!
performSortingOn: aSieve 
	aSieve sortedBySourceCode! !

!DDSortByCode methodsFor: 'printing' stamp: 'HwaJong 11/24/2012 13:20'!
stringForSieveDisplay
^'sort by method'! !

DDMethodSortingType subclass: #DDSortByComplexity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-GUI-Sorting'!

!DDSortByComplexity methodsFor: 'testing' stamp: 'HwaJong 11/8/2012 14:34'!
isSortByComplexity
	^true! !

!DDSortByComplexity methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/13/2012 17:28'!
performSortingOn: aSieve 
aSieve sortedByComplexity! !

!DDSortByComplexity methodsFor: 'printing' stamp: 'HwaJong 11/24/2012 13:21'!
stringForSieveDisplay
^'sort by complexity'! !

DDMethodSortingType subclass: #DDSortByDependency
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-GUI-Sorting'!

!DDSortByDependency methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/8/2012 18:54'!
isSortByDependency
^true! !

!DDSortByDependency methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/13/2012 17:27'!
performSortingOn: aSieve 
aSieve sortedByDependency! !

!DDSortByDependency methodsFor: 'printing' stamp: 'HwaJong 11/24/2012 13:21'!
stringForSieveDisplay
^'sort by dependency'! !

DDMethodSortingType subclass: #DDSortByName
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-GUI-Sorting'!

!DDSortByName methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/15/2012 18:28'!
isSortByName
	^true! !

!DDSortByName methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/13/2012 17:27'!
performSortingOn: aSieve 
aSieve sortedByName! !

!DDSortByName methodsFor: 'printing' stamp: 'HwaJong 11/24/2012 13:20'!
stringForSieveDisplay
^'sort by class'! !

Object subclass: #DisableableNegatableCompiledMethodFilter
	instanceVariableNames: 'compiledMethodFilter isEnabled isNegated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-GUI-FilterPanels'!

!DisableableNegatableCompiledMethodFilter methodsFor: 'accessing' stamp: 'HwaJong 10/24/2012 00:30'!
compiledMethodFilter
	^ compiledMethodFilter! !

!DisableableNegatableCompiledMethodFilter methodsFor: 'accessing' stamp: 'HwaJong 10/24/2012 00:30'!
compiledMethodFilter: aCompiledMethodFilter
	compiledMethodFilter := aCompiledMethodFilter
! !

!DisableableNegatableCompiledMethodFilter methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2013 10:16'!
expectedRunTime
	^compiledMethodFilter expectedRunTime! !

!DisableableNegatableCompiledMethodFilter methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/24/2012 00:39'!
filterIn: anArray 
^self isEnabled 
	ifTrue: [
		self isNegated
			ifTrue: [compiledMethodFilter filterOut: anArray]
			ifFalse: [compiledMethodFilter filterIn: anArray]]
	ifFalse: [anArray]! !

!DisableableNegatableCompiledMethodFilter methodsFor: 'initialize-release' stamp: 'HwaJong 10/24/2012 00:32'!
initialize
super initialize.
isEnabled := true.
isNegated := false.! !

!DisableableNegatableCompiledMethodFilter methodsFor: 'accessing' stamp: 'HwaJong 10/24/2012 00:30'!
isEnabled
	^ isEnabled! !

!DisableableNegatableCompiledMethodFilter methodsFor: 'accessing' stamp: 'HwaJong 10/24/2012 00:30'!
isEnabled: aBoolean
	isEnabled := aBoolean
! !

!DisableableNegatableCompiledMethodFilter methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/24/2012 00:36'!
isMeaningful
^self isEnabled and: [compiledMethodFilter isMeaningful] ! !

!DisableableNegatableCompiledMethodFilter methodsFor: 'accessing' stamp: 'HwaJong 10/24/2012 00:30'!
isNegated
	^ isNegated! !

!DisableableNegatableCompiledMethodFilter methodsFor: 'accessing' stamp: 'HwaJong 10/24/2012 00:30'!
isNegated: aBoolean
	isNegated := aBoolean
! !

!DisableableNegatableCompiledMethodFilter methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2013 09:46'!
runFiltersAndSortForGuiModel: aSieveGUIModel 
	(self isEnabled and: [self isMeaningful]) ifTrue: [aSieveGUIModel runFiltersAndSort]! !

!DisableableNegatableCompiledMethodFilter methodsFor: 'toggle' stamp: 'HwaJong 10/24/2012 00:31'!
toggleEnable

	self isEnabled: self isEnabled not! !

!DisableableNegatableCompiledMethodFilter methodsFor: 'toggle' stamp: 'HwaJong 11/2/2012 14:16'!
toggleNegated
	self isNegated: self isNegated not! !

Object subclass: #FilterPanel
	instanceVariableNames: 'filter guiModel morph textMorphChangedByNegation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-GUI-FilterPanels'!

FilterPanel subclass: #ClassNameOrMethodNameContainsPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-GUI-FilterPanels'!

!ClassNameOrMethodNameContainsPanel class methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/22/2012 11:06'!
humanReadableString

	^'class name or method name ...'! !

!ClassNameOrMethodNameContainsPanel class methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/24/2012 01:12'!
rawFilterForGUIModel
^ClassNameOrMethodNameContains string: ''! !

!ClassNameOrMethodNameContainsPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/22/2012 11:06'!
contentsForChangingTextMorph
^filter isNegated
	ifTrue: ['class or method name does not have']
	ifFalse: ['class or method name has'] ! !

!ClassNameOrMethodNameContainsPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/24/2012 00:36'!
getNameField

	^filter compiledMethodFilter string.! !

!ClassNameOrMethodNameContainsPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/2/2012 17:20'!
rowMorphElementsOn: bil
textMorphChangedByNegation := bil newLabel: self contentsForChangingTextMorph.
	^(super rowMorphElementsOn: bil), {textMorphChangedByNegation. (bil newTextEntryFor: self getText: #getNameField setText: #setNameField: help: '')}.
! !

!ClassNameOrMethodNameContainsPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/2/2013 10:24'!
setNameField: aString

	filter compiledMethodFilter string: aString.
	self runFiltersAndSortForGuiModel.
	^true! !

!FilterPanel class methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/24/2012 01:18'!
forGUIModel

	^self on: (DisableableNegatableCompiledMethodFilter new 
		compiledMethodFilter: (self rawFilterForGUIModel))! !

!FilterPanel class methodsFor: 'as yet unclassified' stamp: 'hjo 8/27/2012 15:59'!
on: filterObject

	^self new filter: filterObject.! !

!FilterPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/25/2013 01:27'!
chooseClassButton
	^UITheme builder newButtonFor: self action: #chooseClassAction label: '...' help: nil! !

!FilterPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/25/2013 01:59'!
chooseClassOrGlobalButton
	^UITheme builder newButtonFor: self action: #chooseClassOrGlobalAction label: '...' help: nil! !

!FilterPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/25/2013 01:28'!
classFromUser

	^(Smalltalk includesKey: #ClassSearch)
		ifTrue: [ (Smalltalk classNamed: #ClassSearch) chooseFromOwner: StandardWindow new. ]
		ifFalse: [ 
			(Smalltalk includesKey: #ListDialogWindow)
				ifTrue: [
					 ((Smalltalk classNamed: #ListDialogWindow) new
						getList: [ :r| Smalltalk allClasses select: [:e | r search: e name ]];
						title: 'Class search';
						yourself) chooseFromOwner: StandardWindow new.
					 ]
				ifFalse: [ self shouldBeImplemented ]
			 ].! !

!FilterPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/25/2013 02:08'!
classOrGlobalFromUser

	^(Smalltalk includesKey: #ClassSearch)
		ifTrue: [ |list|
			list:=
				(Smalltalk classNamed: #ListDialogWindow) new
					getList: [ :r| (Smalltalk keys asSortedCollection) select: [:e | r search: e name ]];
					title: 'Class or Global search';
					yourself.
			(StandardWindow new openModal: list) answer]
		ifFalse: [ 
			(Smalltalk includesKey: #ListDialogWindow)
				ifTrue: [
					 (((Smalltalk classNamed: #ListDialogWindow) new
						getList: [ :r| (Smalltalk keys asSortedCollection) select: [:e | r search: e name ]];
						title: 'Class or Global search';
						yourself) chooseFromOwner: StandardWindow new) asSymbol.
					 ]
				ifFalse: [ self shouldBeImplemented ]
			 ].! !

!FilterPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/24/2012 01:32'!
defaultMorph
| bil |
bil := UITheme builder.	
^bil newRow: (self rowMorphElementsOn: bil)! !

!FilterPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/24/2012 01:20'!
enablingCheckbox: bil
^bil newCheckboxFor: self getSelected: #filterActivateCheckboxSelected setSelected: #filterActivateCheckboxSelected: getEnabled: nil label: '' help: 'turn this filter on/off'.! !

!FilterPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2013 10:15'!
expectedRunTime
	^filter expectedRunTime! !

!FilterPanel methodsFor: 'as yet unclassified' stamp: 'hjo 8/27/2012 15:51'!
filter
	^filter! !

!FilterPanel methodsFor: 'as yet unclassified' stamp: 'hjo 8/27/2012 15:52'!
filter: anObject
	filter := anObject! !

!FilterPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/24/2012 01:10'!
filterActivateCheckboxSelected
^filter isEnabled! !

!FilterPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/20/2013 12:21'!
filterActivateCheckboxSelected: aBoolean
filter isEnabled: aBoolean.
guiModel runFiltersAndSort.! !

!FilterPanel methodsFor: 'as yet unclassified' stamp: 'hjo 8/27/2012 16:21'!
guiModel: anObject
	guiModel := anObject! !

!FilterPanel methodsFor: 'as yet unclassified' stamp: 'hjo 8/28/2012 10:32'!
morph	
	morph isNil ifTrue: [ morph := self defaultMorph ].
	^morph! !

!FilterPanel methodsFor: 'as yet unclassified' stamp: 'hjo 8/27/2012 19:35'!
morph: aMorph
	morph := aMorph! !

!FilterPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/24/2012 01:45'!
rowMorphElementsOn: bil

	^{self enablingCheckbox: bil}.
! !

!FilterPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/2/2013 10:24'!
runFiltersAndSortForGuiModel

	filter runFiltersAndSortForGuiModel: guiModel.! !

!FilterPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2013 09:46'!
runFiltersAndSortForGuiModel: aSieveGUIModel 
	filter runFiltersAndSortForGuiModel: aSieveGUIModel ! !

!FilterPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/2/2012 17:26'!
toggleNegated
filter toggleNegated.
self updateTextMorphChangedByNegation.! !

!FilterPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/2/2012 17:26'!
updateTextMorphChangedByNegation
textMorphChangedByNegation contents: self contentsForChangingTextMorph! !

FilterPanel subclass: #MethodClassCanUnderstandPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-GUI-FilterPanels'!

!MethodClassCanUnderstandPanel class methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 01:11'!
humanReadableString
^'class understands message ...'! !

!MethodClassCanUnderstandPanel class methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/24/2012 01:14'!
rawFilterForGUIModel
^MethodClassCanUnderstand message: #yourself
! !

!MethodClassCanUnderstandPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/2/2012 16:08'!
contentsForChangingTextMorph
^filter isNegated
	ifTrue: ['class does not understand']
	ifFalse: ['class understands'] ! !

!MethodClassCanUnderstandPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/24/2012 00:45'!
getSelector
	^filter compiledMethodFilter message! !

!MethodClassCanUnderstandPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/2/2012 17:22'!
rowMorphElementsOn: bil
textMorphChangedByNegation := bil newLabel: 'class understands '.
^(super rowMorphElementsOn: bil), {textMorphChangedByNegation. (bil newTextEntryFor: self getText: #getSelector setText: #setSelector: help: '')}! !

!MethodClassCanUnderstandPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/2/2013 10:25'!
setSelector: aString 
	filter compiledMethodFilter message: aString asSymbol.
	self runFiltersAndSortForGuiModel..
	^true! !

FilterPanel subclass: #MethodClassImplementsMethodPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-GUI-FilterPanels'!

!MethodClassImplementsMethodPanel class methodsFor: 'as yet unclassified' stamp: 'HwaJong 9/30/2013 11:11'!
humanReadableString
	^'class implements method ...'! !

!MethodClassImplementsMethodPanel class methodsFor: 'as yet unclassified' stamp: 'HwaJong 9/30/2013 11:12'!
rawFilterForGUIModel
^MethodClassImplementsMethod new! !

!MethodClassImplementsMethodPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 9/30/2013 11:15'!
contentsForChangingTextMorph
	^filter isNegated
		ifTrue: ['class does not implements ']
		ifFalse: ['class implements '] ! !

!MethodClassImplementsMethodPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 9/30/2013 11:16'!
getSelector
	^filter compiledMethodFilter selector! !

!MethodClassImplementsMethodPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 9/30/2013 11:14'!
rowMorphElementsOn: bil
	textMorphChangedByNegation := bil newLabel: self contentsForChangingTextMorph.
	^ (super rowMorphElementsOn: bil)
		,
			{textMorphChangedByNegation.
			(bil
				newTextEntryFor: self
				getText: #getSelector
				setText: #setSelector:
				help: '')}! !

!MethodClassImplementsMethodPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/2/2013 10:25'!
setSelector: aString 
	filter compiledMethodFilter selector: aString asSymbol.
	self runFiltersAndSortForGuiModel..
	^true! !

FilterPanel subclass: #MethodClassInheritsPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-GUI-FilterPanels'!

!MethodClassInheritsPanel class methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 01:09'!
humanReadableString
	^'class inherits from ...'! !

!MethodClassInheritsPanel class methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/24/2012 01:14'!
rawFilterForGUIModel
^MethodClassInherits methodClass: Object! !

!MethodClassInheritsPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/25/2013 01:28'!
chooseClassAction
	self setClassName: (self classFromUser) name.
	self changed: #getClassName! !

!MethodClassInheritsPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/2/2012 16:19'!
contentsForChangingTextMorph
^filter isNegated
	ifTrue: ['class does not inherit from']
	ifFalse: ['class inherits from'] ! !

!MethodClassInheritsPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/24/2012 00:52'!
getClassName
	^filter compiledMethodFilter methodClass name! !

!MethodClassInheritsPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/25/2013 00:23'!
rowMorphElementsOn: bil
	textMorphChangedByNegation := bil newLabel: self contentsForChangingTextMorph.
	^ (super rowMorphElementsOn: bil)
		,
			{textMorphChangedByNegation.
			(bil
				newTextEntryFor: self
				getText: #getClassName
				setText: #setClassName:
				help: '').
			self chooseClassButton}! !

!MethodClassInheritsPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/2/2013 10:25'!
setClassName: aString 
	filter compiledMethodFilter methodClass: (Smalltalk classNamed: aString).
	self runFiltersAndSortForGuiModel..
	^true! !

FilterPanel subclass: #MethodClassIsClassOrSuperclassPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-GUI-FilterPanels'!

!MethodClassIsClassOrSuperclassPanel class methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 01:09'!
humanReadableString
	^'method class is ... or its superclass'! !

!MethodClassIsClassOrSuperclassPanel class methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/24/2012 01:14'!
rawFilterForGUIModel
^MethodClassIsClassOrSuperclass methodClass: Object! !

!MethodClassIsClassOrSuperclassPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/25/2013 01:30'!
chooseClassAction
	self setClassName: (self classFromUser) name.
	self changed: #getClassName! !

!MethodClassIsClassOrSuperclassPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/2/2012 16:43'!
contentsForChangingTextMorph
^filter isNegated
	ifTrue: ['not class or superclass of']
	ifFalse: ['class or superclass of'] ! !

!MethodClassIsClassOrSuperclassPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/24/2012 00:56'!
getClassName
	^filter compiledMethodFilter nameOfMethodClass! !

!MethodClassIsClassOrSuperclassPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/25/2013 01:29'!
rowMorphElementsOn: bil
textMorphChangedByNegation := bil newLabel: self contentsForChangingTextMorph.
^(super rowMorphElementsOn: bil), {textMorphChangedByNegation. (bil newTextEntryFor: self getText: #getClassName setText: #setClassName: help: ''). self chooseClassButton}! !

!MethodClassIsClassOrSuperclassPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/2/2013 10:25'!
setClassName: aByteString 
	[filter compiledMethodFilter methodClass: (Smalltalk classNamed: aByteString).
	self runFiltersAndSortForGuiModel] on: MessageNotUnderstood do: [:except| UIManager default inform: 'Class name is wrong'. self setClassName: self getClassName. self changed: #getClassName]. 
	^true! !

FilterPanel subclass: #MethodOfPackagePanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-GUI-FilterPanels'!

!MethodOfPackagePanel class methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/13/2012 17:16'!
humanReadableString
	^'in package ...'! !

!MethodOfPackagePanel class methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/24/2012 01:14'!
rawFilterForGUIModel
^MethodOfPackage named: ''! !

!MethodOfPackagePanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/2/2012 16:50'!
contentsForChangingTextMorph
^filter isNegated
	ifTrue: ['not in package']
	ifFalse: ['in package'] ! !

!MethodOfPackagePanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/24/2012 00:59'!
getPackageName

	^filter compiledMethodFilter packageInfoName! !

!MethodOfPackagePanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/2/2012 17:23'!
rowMorphElementsOn: bil
textMorphChangedByNegation := bil newLabel: self contentsForChangingTextMorph.
^(super rowMorphElementsOn: bil), {textMorphChangedByNegation. (bil newTextEntryFor: self getText: #getPackageName setText: #setPackageName: help: '')}! !

!MethodOfPackagePanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/2/2013 10:25'!
setPackageName: aString 
	filter compiledMethodFilter packageInfoNamed: aString.
	self runFiltersAndSortForGuiModel.
	^true! !

FilterPanel subclass: #NameContainsPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-GUI-FilterPanels'!

!NameContainsPanel class methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/13/2012 16:58'!
humanReadableString

	^'name ...'! !

!NameContainsPanel class methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/13/2012 17:07'!
rawFilterForGUIModel
^AnyNameContains string: ''! !

!NameContainsPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/13/2012 16:58'!
contentsForChangingTextMorph
^filter isNegated
	ifTrue: ['name does not have']
	ifFalse: ['name has'] ! !

!NameContainsPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/13/2012 16:58'!
getNameField

	^filter compiledMethodFilter string.! !

!NameContainsPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/13/2012 16:58'!
rowMorphElementsOn: bil
textMorphChangedByNegation := bil newLabel: self contentsForChangingTextMorph.
	^(super rowMorphElementsOn: bil), {textMorphChangedByNegation. (bil newTextEntryFor: self getText: #getNameField setText: #setNameField: help: '')}.
! !

!NameContainsPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/2/2013 10:25'!
setNameField: aString

	filter compiledMethodFilter string: aString.
	self runFiltersAndSortForGuiModel.
	^true! !

FilterPanel subclass: #ReferencesGlobalPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-GUI-FilterPanels'!

!ReferencesGlobalPanel class methodsFor: 'answering' stamp: 'HwaJong 9/29/2013 18:28'!
humanReadableString
	^'refers to global or class...'! !

!ReferencesGlobalPanel class methodsFor: 'answering' stamp: 'HwaJong 9/29/2013 18:29'!
rawFilterForGUIModel
	^ReferencesGlobal new string: ''! !

!ReferencesGlobalPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/25/2013 01:58'!
chooseClassOrGlobalAction
	self setSelector: (self classOrGlobalFromUser).
	self changed: #getSelector! !

!ReferencesGlobalPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 9/29/2013 18:34'!
contentsForChangingTextMorph
	^filter isNegated
		ifTrue: ['not refers to global or class ']
		ifFalse: ['refers to global or class '] ! !

!ReferencesGlobalPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 9/29/2013 18:42'!
getSelector
	^filter compiledMethodFilter string! !

!ReferencesGlobalPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/25/2013 01:56'!
rowMorphElementsOn: bil

textMorphChangedByNegation := bil newLabel: self contentsForChangingTextMorph.
^(super rowMorphElementsOn: bil), {textMorphChangedByNegation. (bil newTextEntryFor: self getText: #getSelector setText: #setSelector: help: ''). self chooseClassOrGlobalButton}! !

!ReferencesGlobalPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/2/2013 10:25'!
setSelector: aString 
	filter compiledMethodFilter string: aString.
	self runFiltersAndSortForGuiModel.
	^true! !

FilterPanel subclass: #SelectorIsPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-GUI-FilterPanels'!

!SelectorIsPanel class methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 01:06'!
humanReadableString
	^'selector is ...'! !

!SelectorIsPanel class methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/24/2012 01:14'!
rawFilterForGUIModel
^SelectorIs selector: #yourself! !

!SelectorIsPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/2/2012 16:01'!
contentsForChangingTextMorph
^filter isNegated
	ifTrue: ['selector isn''t']
	ifFalse: ['selector is'] ! !

!SelectorIsPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/24/2012 01:01'!
getSelector
	^filter compiledMethodFilter selector asString! !

!SelectorIsPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/2/2012 17:24'!
rowMorphElementsOn: bil
textMorphChangedByNegation := bil newLabel: self contentsForChangingTextMorph.
^(super rowMorphElementsOn: bil), {textMorphChangedByNegation. (bil newTextEntryFor: self getText: #getSelector setText: #setSelector: help: '')}! !

!SelectorIsPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/2/2013 10:25'!
setSelector: aString 
	filter compiledMethodFilter selector: aString asSymbol.
	self runFiltersAndSortForGuiModel.
	^true! !

FilterPanel subclass: #SendsMessagePanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-GUI-FilterPanels'!

!SendsMessagePanel class methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 01:10'!
humanReadableString
	^'sends message ...'! !

!SendsMessagePanel class methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/24/2012 01:15'!
rawFilterForGUIModel
^SendsMessage selector: ''! !

!SendsMessagePanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/2/2012 17:02'!
contentsForChangingTextMorph
^filter isNegated
	ifTrue: ['does not send']
	ifFalse: ['sends'] ! !

!SendsMessagePanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/24/2012 01:02'!
getSendsMessage
	^filter compiledMethodFilter selector asString! !

!SendsMessagePanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/2/2012 17:24'!
rowMorphElementsOn: bil
textMorphChangedByNegation := bil newLabel: self contentsForChangingTextMorph.
^(super rowMorphElementsOn: bil), {textMorphChangedByNegation. (bil newTextEntryFor: self getText: #getSendsMessage setText: #setSendsMessage: help: '')}! !

!SendsMessagePanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/2/2013 10:25'!
setSendsMessage: aByteString 
	filter compiledMethodFilter selector: aByteString asSymbol.
	self runFiltersAndSortForGuiModel.
	^true! !

FilterPanel subclass: #SourceCodeContainsPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-GUI-FilterPanels'!

!SourceCodeContainsPanel class methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 01:10'!
humanReadableString
^'contains string ...'! !

!SourceCodeContainsPanel class methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/24/2012 01:15'!
rawFilterForGUIModel
^SourceCodeContains string: ''! !

!SourceCodeContainsPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/2/2012 17:10'!
contentsForChangingTextMorph
^filter isNegated
	ifTrue: ['does not contain string']
	ifFalse: ['contains string'] ! !

!SourceCodeContainsPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/24/2012 01:07'!
getString
^filter compiledMethodFilter string! !

!SourceCodeContainsPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/2/2012 17:24'!
rowMorphElementsOn: bil
textMorphChangedByNegation := bil newLabel: 'contains string'.
^(super rowMorphElementsOn: bil), {textMorphChangedByNegation. (bil newTextEntryFor: self getText: #getString setText: #setString: help: '')}! !

!SourceCodeContainsPanel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/2/2013 10:26'!
setString: aByteString 
filter compiledMethodFilter string: aByteString.
self runFiltersAndSortForGuiModel.
^true! !

Object subclass: #Sieve
	instanceVariableNames: 'methods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-Model-Main'!

!Sieve class methodsFor: 'world menu' stamp: 'HwaJong 12/11/2012 01:41'!
menuCommandOn: aBuilder 
	<worldMenu> 
	(aBuilder item: #'Sieve')
			parent: #DevHelpers;
			action:[ | gui |
				gui := SieveGUIModel new open.
				]; 
			icon: SieveGUIModel appIcon;
			help: 'narrow down method with filtering conditions'.! !

!Sieve methodsFor: 'adding' stamp: 'hjo 2/4/2011 13:07'!
addMethod: aCompiledMethod 

	(methods includes: aCompiledMethod)
		ifFalse: [methods := methods , (Array with: aCompiledMethod)]! !

!Sieve methodsFor: 'collecting' stamp: 'hjo 6/6/2011 17:18'!
classes

	^(methods collect: #methodClass) asSet  ! !

!Sieve methodsFor: 'filtering' stamp: 'hjo 4/1/2012 11:05'!
filterInWith: aCompiledMethodFilter

	methods := aCompiledMethodFilter filterIn: methods.! !

!Sieve methodsFor: 'filtering' stamp: 'hjo 4/1/2012 11:05'!
filterOutWith: aCompiledMethodFilter

	methods := aCompiledMethodFilter filterOut: methods.! !

!Sieve methodsFor: 'initialize-release' stamp: 'hjo 2/4/2011 13:08'!
initialize

	super initialize.
	methods := OrderedCollection new.! !

!Sieve methodsFor: 'adding' stamp: 'hjo 9/22/2011 15:03'!
initializeWithAll

	methods := Smalltalk allMethods.! !

!Sieve methodsFor: 'collecting' stamp: 'hjo 4/1/2012 10:49'!
methodCount

	^methods size! !

!Sieve methodsFor: 'collecting' stamp: 'hjo 2/2/2011 18:49'!
methodReferences

	^methods collect: #methodReference.! !

!Sieve methodsFor: 'accessing' stamp: 'hjo 4/2/2012 09:28'!
methods

	^methods! !

!Sieve methodsFor: 'filtering-featured' stamp: 'hjo 4/1/2012 11:06'!
notOfClassInheritFrom: aClass 

	self filterOutWith: (MethodClassInherits methodClass: aClass).! !

!Sieve methodsFor: 'filtering-featured' stamp: 'hjo 4/1/2012 11:05'!
notOfPackageNamed: aByteString 

	self filterOutWith: (MethodOfPackage named: aByteString)! !

!Sieve methodsFor: 'filtering-featured' stamp: 'hjo 4/1/2012 11:17'!
onlyInstanceSide

	self filterInWith: (InstanceSideMethod new)! !

!Sieve methodsFor: 'filtering-featured' stamp: 'hjo 4/1/2012 11:26'!
onlyOfAllSuperclassesIncluding: aClass 

	self filterInWith: (MethodClassIsClassOrSuperclass methodClass: aClass).! !

!Sieve methodsFor: 'filtering-featured' stamp: 'hjo 4/1/2012 11:33'!
onlyOfClass: aClass 

	self filterInWith: (MethodClassIs methodClass: aClass).! !

!Sieve methodsFor: 'filtering-featured' stamp: 'hjo 4/1/2012 11:08'!
onlyOfClassInheritFrom: aClass 

	self filterInWith: (MethodClassInherits methodClass: aClass)! !

!Sieve methodsFor: 'filtering-featured' stamp: 'hjo 4/1/2012 11:40'!
onlyOfClassThatCanUnderstand: aSymbol

	self filterInWith: (MethodClassCanUnderstand message: aSymbol)! !

!Sieve methodsFor: 'filtering-featured' stamp: 'hjo 4/1/2012 18:30'!
onlyOfClassesBeginsWith: aString 

	self filterInWith: (MethodClassNameBegins with: aString).! !

!Sieve methodsFor: 'filtering-featured' stamp: 'hjo 4/1/2012 11:07'!
onlyOfPackageNamed: aByteString 

	self filterInWith: (MethodOfPackage named: aByteString).! !

!Sieve methodsFor: 'filtering-featured' stamp: 'hjo 4/1/2012 18:42'!
onlyOfSourceCodeContaining: aString 

	self filterInWith: (SourceCodeContains string: aString)! !

!Sieve methodsFor: 'filtering-featured' stamp: 'hjo 4/1/2012 18:42'!
onlyOfSourceCodeDoesNotContain: aString 

	self filterOutWith: (SourceCodeContains string: aString)
	! !

!Sieve methodsFor: 'filtering-featured' stamp: 'hjo 4/1/2012 18:55'!
onlyOfTheirNameContains: aString
 
	self filterInWith: (ClassNameOrMethodNameContains string: aString).! !

!Sieve methodsFor: 'filtering-featured' stamp: 'hjo 2/15/2012 20:53'!
onlyOfThoseHavingPragma

	methods := methods select: [:each| each pragmas notEmpty ]! !

!Sieve methodsFor: 'filtering-featured' stamp: 'hjo 4/1/2012 19:08'!
onlySelectorBeginsWith: aString 

	self filterInWith: (SelectorBegins with: aString)! !

!Sieve methodsFor: 'filtering-featured' stamp: 'hjo 4/1/2012 19:36'!
onlySelectorContains: aByteString 

	self filterInWith: (SelectorContains string: aByteString)! !

!Sieve methodsFor: 'filtering-featured' stamp: 'hjo 4/1/2012 20:51'!
onlyThoseHasTempNamed: aByteString 

	self filterInWith: (HasTempNamed string: aByteString).! !

!Sieve methodsFor: 'filtering-featured' stamp: 'hjo 4/1/2012 20:59'!
onlyThoseSendsMessage: aSymbol 

	self filterInWith: (SendsMessage selector: aSymbol).! !

!Sieve methodsFor: 'filtering-featured' stamp: 'hjo 4/1/2012 21:04'!
onlyWithSelector: aSymbol 

	self filterInWith: (SelectorIs selector: aSymbol).! !

!Sieve methodsFor: 'sorting' stamp: 'hjo 4/2/2012 17:36'!
sortedByClassThenComplexity

	| sd |
	sd := (UnarySortDescriptor ascendingBy: [:each| each methodClass name]) subSortDescriptor: ((UnarySortDescriptor ascendingBy: #size) subSortDescriptor: (UnarySortDescriptor ascendingBy: #selector)).
	methods := methods asSortedCollection: sd! !

!Sieve methodsFor: 'sorting' stamp: 'hjo 3/31/2012 22:52'!
sortedByComplexity

	| sd |
	sd := (UnarySortDescriptor ascendingBy: #size) subSortDescriptor: ((UnarySortDescriptor ascendingBy: [:each| each methodClass name]) subSortDescriptor: (UnarySortDescriptor ascendingBy: #selector)).
	methods := methods asSortedCollection: sd! !

!Sieve methodsFor: 'sorting' stamp: 'hjo 1/16/2012 11:47'!
sortedByDependency

	| classHierarchySort sendSort classNameSort selectorSort |
	classHierarchySort := BinarySortDescriptor ascendingBy: [:cm1 :cm2| cm2 methodClass inheritsFrom: cm1 methodClass].
	sendSort := BinarySortDescriptor ascendingBy: [:cm1 :cm2| cm2 messages includes: cm1 selector ].
	classNameSort := UnarySortDescriptor ascendingBy: [:cm| cm methodClass name].
	selectorSort := UnarySortDescriptor ascendingBy: #selector.  
	classHierarchySort chainSubSortDescriptors: {sendSort. classNameSort. selectorSort}.  
	methods := methods asSortedCollection: classHierarchySort.! !

!Sieve methodsFor: 'sorting' stamp: 'HwaJong 11/8/2012 14:10'!
sortedByName

	| sd |
	sd := (UnarySortDescriptor ascendingBy: [:each| each methodClass name]) subSortDescriptor: (UnarySortDescriptor ascendingBy: #selector).
	methods := methods asSortedCollection: sd! !

!Sieve methodsFor: 'sorting' stamp: 'hjo 1/30/2011 15:20'!
sortedBySourceCode

	methods := methods asSortedCollection: [:a :b| a getSource asString <= b getSource asString ]! !

!Sieve methodsFor: 'collecting' stamp: 'hjo 6/6/2011 17:19'!
superclasses

	^self classes collect: #superclass! !

Object subclass: #SieveGUIBuilder
	instanceVariableNames: 'builder themeBuilder model filterListMorph methodListMorph methodDefinitionTextMorph window addFilterButton removeFilterButton moveFilterUpButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SieveCommon-GUI-Main'!

!SieveGUIBuilder methodsFor: 'accessing' stamp: 'HwaJong 11/5/2012 12:34'!
addFilterButton
^addFilterButton setDefault: #defaultAddFilterButton for: self withSetter: #addFilterButton:! !

!SieveGUIBuilder methodsFor: 'accessing' stamp: 'HwaJong 11/5/2012 12:33'!
addFilterButton: anObject
		
	addFilterButton := anObject! !

!SieveGUIBuilder methodsFor: 'accessing' stamp: 'HwaJong 11/5/2012 10:36'!
classDefinitionTextMorph
^(self themeBuilder)
		newTextEditorFor: (self model)
		getText: #classDefinitionOfSelectedItem
		setText: #classDefinitionOfSelectedItem:! !

!SieveGUIBuilder methodsFor: 'defaults' stamp: 'HwaJong 11/5/2012 12:39'!
defaultAddFilterButton
|aButton|
aButton := (self themeBuilder) newOKButton.
aButton
	model: (self model);
	action: #addFilter.
aButton labelMorph contents: '+'.
^aButton! !

!SieveGUIBuilder methodsFor: 'defaults' stamp: 'HwaJong 11/5/2012 11:09'!
defaultFilterListMorph
^((self themeBuilder)
		newMorphListFor: (self model)
		list: #getFilterList
		getSelected: #selectionIndexOfFilterList
		setSelected: #selectionIndexOfFilterList:
		getEnabled: #getFilterListEnabled
		help: 'add/remove filters')
		getMenuSelector: #popUpMenuOfFilterListOnMenu:.! !

!SieveGUIBuilder methodsFor: 'defaults' stamp: 'HwaJong 11/5/2012 11:02'!
defaultMethodDefinitionTextMorph
^(self themeBuilder)
		newTextEditorFor: (self model)
		getText: #methodDefinitionOfSelectedItem
		setText: #methodDefinitionOfSelectedItem:.! !

!SieveGUIBuilder methodsFor: 'defaults' stamp: 'HwaJong 3/23/2013 14:32'!
defaultMethodListMorph
^(self themeBuilder newListFor: (self model)
		list: self selectorForGettingMethodDataForListMorph
		selected: #selectionIndexOfMethodList
		changeSelected: #selectionIndexOfMethodList:
		help: 'search result')
			getMenuSelector: #popUpMenuOfMethodListOnMenu:;
			keystrokeActionSelector: #keyEvent:fromMethodList:;
			getListSizeSelector: #getMethodListSize;
			getListElementSelector: #getMethodListElementSelector:;
			yourself.! !

!SieveGUIBuilder methodsFor: 'defaults' stamp: 'HwaJong 11/5/2012 12:47'!
defaultMoveFilterUpButton
|aButton|
aButton := self themeBuilder newOKButton.
aButton 
	model: (self model);
	action: #moveSelectedFilterUp.
aButton labelMorph contents: 'up'.
^aButton! !

!SieveGUIBuilder methodsFor: 'defaults' stamp: 'HwaJong 11/5/2012 12:43'!
defaultRemoveFilterButton
|aButton|
aButton := self themeBuilder newOKButton.
aButton
	model: (self model);
	action: #removeSelectedFilter.
aButton labelMorph contents: '-'.
^aButton! !

!SieveGUIBuilder methodsFor: 'defaults' stamp: 'HwaJong 11/5/2012 10:19'!
defaultThemeBuilder
^UITheme builder! !

!SieveGUIBuilder methodsFor: 'defaults' stamp: 'HwaJong 10/6/2013 19:38'!
defaultWindow
^(((self themeBuilder)
		newRow:
			{((self themeBuilder)
				newColumn:
					{((self themeBuilder)
						newColumn:
							{self filterListMorph.
							self filterButtons.
							self sortingPane}).
					self methodListMorph.
					self itemCountStatusPanel}).
			((self themeBuilder)
				newColumn:
					{self classDefinitionTextMorph.
					self methodDefinitionTextMorph})})
					openInWindowLabeled: 'Sieve')
						model: self model;
						yourself.! !

!SieveGUIBuilder methodsFor: 'private' stamp: 'HwaJong 11/5/2012 12:49'!
filterButtons
|filterButtons|
filterButtons := (self themeBuilder)
		newRow:
			{self addFilterButton.
			self removeFilterButton.
			self moveFilterUpButton.
			self moveFilterDownButton}.
^filterButtons! !

!SieveGUIBuilder methodsFor: 'accessing' stamp: 'HwaJong 11/5/2012 10:41'!
filterListMorph
^filterListMorph setDefault: #defaultFilterListMorph for: self withSetter: #filterListMorph:! !

!SieveGUIBuilder methodsFor: 'accessing' stamp: 'HwaJong 11/5/2012 10:41'!
filterListMorph: aPluggableMorphListMorph 
	filterListMorph := aPluggableMorphListMorph! !

!SieveGUIBuilder methodsFor: 'private' stamp: 'HwaJong 11/5/2012 10:28'!
itemCountStatusPanel
^(self themeBuilder) newLabelFor: (self model) getLabel: #getListSizeLabel getEnabled: #listSizeLabelIsEnabled! !

!SieveGUIBuilder methodsFor: 'accessing' stamp: 'HwaJong 11/5/2012 11:01'!
methodDefinitionTextMorph
^methodDefinitionTextMorph setDefault: #defaultMethodDefinitionTextMorph for: self withSetter: #methodDefinitionTextMorph:! !

!SieveGUIBuilder methodsFor: 'accessing' stamp: 'HwaJong 11/5/2012 11:02'!
methodDefinitionTextMorph: aPluggableTextMorph 
methodDefinitionTextMorph := aPluggableTextMorph! !

!SieveGUIBuilder methodsFor: 'accessing' stamp: 'HwaJong 11/5/2012 10:45'!
methodListMorph
^methodListMorph setDefault: #defaultMethodListMorph for: self withSetter: #methodListMorph:! !

!SieveGUIBuilder methodsFor: 'accessing' stamp: 'HwaJong 11/5/2012 10:45'!
methodListMorph: aPluggableListMorph 
	methodListMorph := aPluggableListMorph! !

!SieveGUIBuilder methodsFor: 'accessing' stamp: 'HwaJong 11/5/2012 10:25'!
model
	^ model! !

!SieveGUIBuilder methodsFor: 'accessing' stamp: 'HwaJong 11/13/2012 17:28'!
model: aSieve 
model := aSieve ! !

!SieveGUIBuilder methodsFor: 'accessing' stamp: 'HwaJong 11/5/2012 12:50'!
moveFilterDownButton
|aButton|
aButton := self themeBuilder newOKButton.
aButton 
	model: (self model);
	action: #moveSelectedFilterDown.
aButton labelMorph contents: 'dn'.
^aButton
! !

!SieveGUIBuilder methodsFor: 'accessing' stamp: 'HwaJong 11/5/2012 12:46'!
moveFilterUpButton
^moveFilterUpButton setDefault: #defaultMoveFilterUpButton for: self withSetter: #moveFilterUpButton:! !

!SieveGUIBuilder methodsFor: 'accessing' stamp: 'HwaJong 11/5/2012 12:48'!
moveFilterUpButton: aPluggableButtonMorph 
moveFilterUpButton := aPluggableButtonMorph! !

!SieveGUIBuilder methodsFor: 'accessing' stamp: 'HwaJong 11/5/2012 12:44'!
removeFilterButton
^removeFilterButton setDefault: #defaultRemoveFilterButton for: self withSetter: #removeFilterButton:! !

!SieveGUIBuilder methodsFor: 'accessing' stamp: 'HwaJong 11/5/2012 12:44'!
removeFilterButton: aPluggableButton
removeFilterButton := aPluggableButton! !

!SieveGUIBuilder methodsFor: 'private' stamp: 'HwaJong 11/24/2012 13:53'!
sortingPane
^self themeBuilder newDropListFor: model list: #sortingMethods getSelected: #selectionIndexOfSortingMethods setSelected: #selectionIndexOfSortingMethods: help: 'select a sorting method'! !

!SieveGUIBuilder methodsFor: 'accessing' stamp: 'HwaJong 11/5/2012 10:17'!
themeBuilder
^themeBuilder setDefault: #defaultThemeBuilder for: self withSetter: #themeBuilder:! !

!SieveGUIBuilder methodsFor: 'accessing' stamp: 'HwaJong 11/5/2012 10:18'!
themeBuilder: anObject
themeBuilder := anObject! !

!SieveGUIBuilder methodsFor: 'accessing' stamp: 'HwaJong 11/5/2012 11:04'!
window
^window setDefault: #defaultWindow for: self withSetter: #window:! !

!SieveGUIBuilder methodsFor: 'accessing' stamp: 'HwaJong 11/5/2012 11:06'!
window: aSystemWindow 
window := aSystemWindow! !

Object subclass: #SieveGUIModel
	instanceVariableNames: 'listModel filterListModel methodDefText methodSorting sieve sortingMethodListModel'
	classVariableNames: 'IconForm'
	poolDictionaries: ''
	category: 'SieveCommon-GUI-Main'!

!SieveGUIModel class methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/15/2012 00:08'!
appIcon

	IconForm isNil ifTrue: [IconForm := self appIconFormFromCode].
	^IconForm! !

!SieveGUIModel class methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/15/2012 00:06'!
appIconFormFromCode
^(Form
	extent: (16@16)
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 42107522 1171970778 2411116214 3232212903 3752438185 4004425390 4004293804 3769215401 3264912026 2457171317 1229473864 55924053 0 0 0 786884326 3568086188 4286216826 4286085240 4287861651 4289572269 4291414473 4292335575 4293388263 4294309365 4294967295 4294111986 3667696796 909654072 0 0 3565520261 4282137660 4284374622 4286019447 4287532686 4289177511 4291151301 4292072403 4292993505 4293717228 4294506744 4294967295 4294967295 3783953034 0 0 3197013646 4281348144 4283256141 4285098345 4286940549 4288848546 4291019715 4292138196 4293256677 4294111986 4294967295 4294967295 4294967295 3345705835 0 0 582662842 3986792865 4285229931 4283914071 4285361517 4288124823 4291019715 4292927712 4294375158 4294967295 4294638330 4289638062 3947974993 541213250 0 0 0 1218683811 4243253994 4293125091 4290230199 4288782753 4288585374 4288190616 4287006342 4284900966 4283519313 4215949898 1146443093 0 0 0 0 0 2057084060 4294440951 4293848814 4292598747 4292138196 4290361785 4287730065 4285690482 4267465820 1935564382 0 0 0 0 0 0 16777216 2912524697 4294375158 4292664540 4291875024 4289835441 4286874756 4284769380 2790873433 0 0 0 0 0 0 0 0 227183242 3584139681 4294309365 4292335575 4289506476 4285756275 3478541910 173956702 0 0 0 0 0 0 0 0 0 678128491 4270887056 4289835441 4287137928 4183513947 559569498 0 0 0 0 0 0 0 0 0 0 0 4189040559 4291940817 4287730065 3931789914 0 0 0 0 0 0 0 0 0 0 0 0 4054822831 4293519849 4288585374 3730331736 0 0 0 0 0 0 0 0 0 0 0 0 2862587807 4293717228 4289111718 3528807765 0 0 0 0 0 0 0 0 0 0 0 0 225077866 2455658078 3765267821 2588428360 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: (0@0))! !

!SieveGUIModel methodsFor: 'filter panels' stamp: 'HwaJong 9/29/2013 18:30'!
addFilter

	| choice panelClassOfChoice |
	choice := UIManager default chooseFrom: self filterPanelNames lines: {self etcFilterPanelClasses size. self etcFilterPanelClasses size + self classFilterPanelClasses size} title: 'pick filter'.
	choice > 0
		ifTrue: [
			panelClassOfChoice := self filterPanelClasses at: choice.
			self addFilterWithClass: panelClassOfChoice. ]! !

!SieveGUIModel methodsFor: 'filter panels' stamp: 'HwaJong 4/20/2013 12:26'!
addFilterWithClass: classFilterPanel 

	| one meaningfulFilters |
	meaningfulFilters := filterListModel list collect: [:each| each filter isMeaningful ].
	
	one := classFilterPanel forGUIModel.
	one guiModel: self.  
	filterListModel atEndInsert: (one).
	self changed: #getFilterList.
	
	(filterListModel list collect: [:each| each filter isMeaningful ]) = meaningfulFilters
		ifTrue: [self runFiltersAndSort].! !

!SieveGUIModel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/6/2013 19:43'!
addModelItemsToWindowMenu: aMenu

	aMenu addLine.
	aMenu add: 'inspect window' action: #inspect.
	aMenu add: 'inspect model'  target: self action: #inspect.
	aMenu add: 'inspect methods'  target: self action: #inspectMethods.
	aMenu add: 'inspect filters'  target: self action: #inspectFilters.! !

!SieveGUIModel methodsFor: 'sorting droplist' stamp: 'HwaJong 3/22/2013 22:27'!
afterSortingDropListChange
	sortingMethodListModel selection performSortingOn: sieve.
	listModel list: sieve methods.
	self setClassOfMethodDefTextForSyntaxColoring.
	self changed: #getMethodListElementSelector:.
	self changed: #getListSizeLabel.
	self changed: #classDefinitionOfSelectedItem.
	self changed: #methodDefinitionOfSelectedItem.
! !

!SieveGUIModel methodsFor: 'filter panels' stamp: 'hjo 8/29/2012 16:21'!
canAddFilterPanel

	^true! !

!SieveGUIModel methodsFor: 'classs definition pane' stamp: 'HwaJong 9/29/2013 20:11'!
classDefinitionOfSelectedItem

	^listModel 
		ifHasSelection: [:sel| sel methodClass definition] 
		ifDoesNotHaveSelection: ['CLASS DEFINITION OF SELECTION']! !

!SieveGUIModel methodsFor: 'filter panels' stamp: 'HwaJong 9/30/2013 11:10'!
classFilterPanelClasses
	^ {MethodClassIsClassOrSuperclassPanel.
	MethodClassInheritsPanel.
	MethodClassCanUnderstandPanel.
	MethodClassImplementsMethodPanel}! !

!SieveGUIModel methodsFor: 'filter panels' stamp: 'HwaJong 9/29/2013 18:27'!
etcFilterPanelClasses
	^ {MethodOfPackagePanel.
	NameContainsPanel.
	ClassNameOrMethodNameContainsPanel.
	ReferencesGlobalPanel}! !

!SieveGUIModel methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/13/2012 17:12'!
filterInWith: filter
	sieve filterInWith: filter! !

!SieveGUIModel methodsFor: 'filter panels' stamp: 'HwaJong 12/7/2012 19:58'!
filterPanelClasses

	^self etcFilterPanelClasses , self classFilterPanelClasses , self methodFilterPanelClasses! !

!SieveGUIModel methodsFor: 'filter panels' stamp: 'HwaJong 10/23/2012 23:36'!
filterPanelNames
	^self filterPanelClasses collect: #humanReadableString! !

!SieveGUIModel methodsFor: 'filter list' stamp: 'HwaJong 3/1/2013 23:10'!
getFilterList

	^filterListModel list collect: [:aFilterPanel | aFilterPanel morph ]! !

!SieveGUIModel methodsFor: 'filter list' stamp: 'hjo 8/26/2012 17:12'!
getFilterListEnabled
	^true! !

!SieveGUIModel methodsFor: 'list size' stamp: 'hjo 8/25/2012 12:03'!
getListSizeLabel

	^listModel list size printString, ' item(s) in the list'! !

!SieveGUIModel methodsFor: 'method list' stamp: 'HwaJong 3/22/2013 22:28'!
getMethodListElementSelector: aSmallInteger 
	|aCompiledMethod|
	aCompiledMethod := listModel list at: aSmallInteger.
	^String streamContents: [:stream|
			stream print:  aCompiledMethod methodClass.
			stream nextPutAll: ' >> '.
			stream nextPutAll: aCompiledMethod selector].! !

!SieveGUIModel methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/14/2013 23:14'!
getMethodListSize
	^listModel list size! !

!SieveGUIModel methodsFor: 'initialize-release' stamp: 'HwaJong 3/1/2013 23:26'!
initialize

	| panels |
	super initialize.
	methodSorting := DDSortByName new.

	sieve := Sieve new.
	sieve initializeWithAll.
	listModel := TGListModel new.
	listModel insertAll: sieve methods at: listModel selectionIndex.
	
	filterListModel := TGListModel new.
	
	sortingMethodListModel := TGListModel new.
	sortingMethodListModel list: {DDNoSort new. DDSortByName new. DDSortByCode new. DDSortByComplexity new. DDSortByDependency new}.
	sortingMethodListModel selectionIndex: 1.! !

!SieveGUIModel methodsFor: 'actions' stamp: 'HwaJong 10/6/2013 19:43'!
inspectFilters
	filterListModel list inspect! !

!SieveGUIModel methodsFor: 'actions' stamp: 'HwaJong 10/6/2013 19:42'!
inspectMethods
	listModel list inspect! !

!SieveGUIModel methodsFor: 'method list' stamp: 'HwaJong 10/2/2013 12:01'!
keyEvent: aCharacter fromMethodList: aPluggableListMorph 
	aCharacter = $b
		ifTrue: [self openBrowserOnSelectedCompiledMethodInMethodList].
	aCharacter = $m
		ifTrue: [self openImplementorsOnSelectedCompiledMethodInMethodList].
	aCharacter = $n
		ifTrue: [self openSendersOnSelectedCompiledMethodInMethodList].
	aCharacter = $N
		ifTrue: [self openClassRefOnSelectedCompiledMethodInMethodList].! !

!SieveGUIModel methodsFor: 'list size' stamp: 'hjo 8/25/2012 12:01'!
listSizeLabelIsEnabled

	^true! !

!SieveGUIModel methodsFor: 'method definition pane' stamp: 'HwaJong 3/1/2013 23:05'!
methodDefinitionOfSelectedItem

	^listModel 
		ifHasSelection: [:sel| sel getSource ] 
		ifDoesNotHaveSelection: ['METHOD DEFINITION OF SELECTION']! !

!SieveGUIModel methodsFor: 'method definition pane' stamp: 'HwaJong 4/20/2013 12:21'!
methodDefinitionOfSelectedItem: aText 

	| method |
	method := listModel selection.
	method methodClass compile: aText.
	self runFiltersAndSort.! !

!SieveGUIModel methodsFor: 'filter panels' stamp: 'HwaJong 12/7/2012 19:57'!
methodFilterPanelClasses
	^ {SendsMessagePanel.
	SelectorIsPanel.
	SourceCodeContainsPanel}! !

!SieveGUIModel methodsFor: 'filter list' stamp: 'HwaJong 11/5/2012 12:20'!
moveSelectedFilterDown
filterListModel moveSelectionDown.
self changed: #getFilterList.! !

!SieveGUIModel methodsFor: 'filter list' stamp: 'HwaJong 11/5/2012 12:15'!
moveSelectedFilterUp
filterListModel moveSelectionUp.
self changed: #getFilterList.! !

!SieveGUIModel methodsFor: 'actions' stamp: 'HwaJong 4/20/2013 12:21'!
negateLogicOfSelectedFilter
|filterPanel|
filterPanel := filterListModel selection.
filterPanel toggleNegated.
self changed: #getFilterList.
self runFiltersAndSort.! !

!SieveGUIModel methodsFor: 'display' stamp: 'HwaJong 11/13/2012 15:21'!
open
	| morphBuilder |
	morphBuilder := SieveGUIBuilder new.
	morphBuilder model: self.
	
	morphBuilder window extent: 1000 @ 600.
	morphBuilder window model: (morphBuilder model).
	
	methodDefText := morphBuilder methodDefinitionTextMorph.
	
	self setClassOfMethodDefTextForSyntaxColoring.! !

!SieveGUIModel methodsFor: 'actions' stamp: 'HwaJong 10/24/2012 02:10'!
openBrowserOnSelectedCompiledMethodInMethodList
listModel selection browse.! !

!SieveGUIModel methodsFor: 'actions' stamp: 'HwaJong 10/2/2013 12:17'!
openClassRefOnSelectedCompiledMethodInMethodList
	SystemNavigation default browseAllCallsOnClass: listModel selection methodClass! !

!SieveGUIModel methodsFor: 'actions' stamp: 'HwaJong 10/2/2013 12:10'!
openImplementorsOnSelectedCompiledMethodInMethodList

	SystemNavigation default browseAllImplementorsOf: listModel selection selector.! !

!SieveGUIModel methodsFor: 'actions' stamp: 'HwaJong 10/2/2013 12:13'!
openSendersOnSelectedCompiledMethodInMethodList
	|sel|
	sel := listModel selection selector.
	SystemNavigation default browseSendersOf: sel name: 'Senders of ', sel printString autoSelect: (sel subStrings: ':') first.! !

!SieveGUIModel methodsFor: 'filter list' stamp: 'HwaJong 10/31/2012 01:34'!
popUpMenuOfFilterListOnMenu: aMenuMorph
aMenuMorph add: 'not' action: #negateLogicOfSelectedFilter.
^aMenuMorph! !

!SieveGUIModel methodsFor: 'method list' stamp: 'HwaJong 10/2/2013 12:18'!
popUpMenuOfMethodListOnMenu: aMenuMorph 
aMenuMorph add: 'open browser' action: #openBrowserOnSelectedCompiledMethodInMethodList.
aMenuMorph add: 'senders' action: #openSendersOnSelectedCompiledMethodInMethodList.
aMenuMorph add: 'implementors' action: #openImplementorsOnSelectedCompiledMethodInMethodList.
aMenuMorph add: 'class refs' action: #openClassRefOnSelectedCompiledMethodInMethodList.
^aMenuMorph! !

!SieveGUIModel methodsFor: 'filter list' stamp: 'HwaJong 10/5/2013 09:45'!
removeSelectedFilter

	filterListModel ifHasSelection: [:selectedFilter|
			filterListModel deleteSelection.
			self changed: #getFilterList.
			selectedFilter runFiltersAndSortForGuiModel: self.
		]
! !

!SieveGUIModel methodsFor: 'filter panels' stamp: 'HwaJong 10/5/2013 10:07'!
runFiltersAndSort

	sieve initializeWithAll.
	self sortedFiltersBySpeed do: [:each| each filter isMeaningful ifTrue: [self filterInWith: each filter] ].
	methodSorting performSortingOn: sieve.
	listModel list: sieve methods.
	self setClassOfMethodDefTextForSyntaxColoring.
	self changed: #getMethodListElementSelector:.
	self changed: #getListSizeLabel.
	self changed: #classDefinitionOfSelectedItem.
	self changed: #methodDefinitionOfSelectedItem.
	self changed: #getFilterList.! !

!SieveGUIModel methodsFor: 'filter list' stamp: 'hjo 8/25/2012 14:52'!
selectionIndexOfFilterList

	^filterListModel selectionIndex ! !

!SieveGUIModel methodsFor: 'filter list' stamp: 'hjo 8/27/2012 06:48'!
selectionIndexOfFilterList: aSmallInteger 

	filterListModel selectionIndex: aSmallInteger.
	self changed: #selectionIndexOfFilterList.! !

!SieveGUIModel methodsFor: 'method list' stamp: 'hjo 8/25/2012 10:33'!
selectionIndexOfMethodList

	^listModel selectionIndex! !

!SieveGUIModel methodsFor: 'method list' stamp: 'HwaJong 10/15/2012 14:32'!
selectionIndexOfMethodList: anInteger 
	listModel selectionIndex: anInteger.
	self setClassOfMethodDefTextForSyntaxColoring.
	self changed: #selectionIndexOfMethodList.
	self changed: #classDefinitionOfSelectedItem.
	self changed: #methodDefinitionOfSelectedItem.! !

!SieveGUIModel methodsFor: 'sorting droplist' stamp: 'HwaJong 11/24/2012 13:34'!
selectionIndexOfSortingMethods
^sortingMethodListModel selectionIndex! !

!SieveGUIModel methodsFor: 'sorting droplist' stamp: 'HwaJong 11/24/2012 13:37'!
selectionIndexOfSortingMethods: anInteger 
	sortingMethodListModel selectionIndex: anInteger.
	self afterSortingDropListChange.! !

!SieveGUIModel methodsFor: 'method list' stamp: 'HwaJong 3/1/2013 23:04'!
setClassOfMethodDefTextForSyntaxColoring
	
	(methodDefText styler) classOrMetaClass: 
		(listModel 
			ifHasSelection: [:sel| sel methodClass] 
			ifDoesNotHaveSelection: [nil]).
	! !

!SieveGUIModel methodsFor: 'method definition pane' stamp: 'HwaJong 10/15/2012 15:15'!
shoutAboutToStyle: aPluggableTextMorph
	aPluggableTextMorph getTextSelector = #classDefinitionOfSelectedItem
		ifTrue: [^true].
	aPluggableTextMorph == methodDefText
		ifTrue: [^true].
	^false.! !

!SieveGUIModel methodsFor: 'filter panels' stamp: 'HwaJong 10/5/2013 10:15'!
sortedFiltersBySpeed

	^filterListModel list asSortedCollection: (UnarySortDescriptor ascendingBy: #expectedRunTime)! !

!SieveGUIModel methodsFor: 'sorting droplist' stamp: 'HwaJong 3/1/2013 23:12'!
sortingMethods
^sortingMethodListModel list collect: [:each| each stringForSieveDisplay]! !

!SieveGUIModel methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/15/2012 00:09'!
taskbarIcon

	^self class appIcon.! !
